<script setup lang="ts">
import { useProductStore } from '@/stores/product'
import { useStockproductStore } from '@/stores/stockproduct'
import { onMounted, ref, computed } from 'vue'
import StockDialog from './StockDialog.vue'
import type Product from '@/types/Product'

const backendURL = import.meta.env.VITE_BACKEND_URL
const productStore = useProductStore()
const stockproductStore = useStockproductStore()
const selectedProduct = ref<Product | null>(null)

onMounted(() => {
  productStore.getProducts()
})

onMounted(async () => {
  await stockproductStore.getStockproduct()
  // await productStore.getProductsByCategory(productStore.category);
})

const search = ref('')
const editProduct = (product: Product) => {
  productStore.editProduct(product)
}

const deleteProduct = (productId: number) => {
  productStore.deleteProduct(productId)
}
const selectProduct = (product: Product) => {
  selectedProduct.value = product
}

const isSelected = (product: Product) => {
  return selectedProduct.value !== null && selectedProduct.value.id === product.id
}

const searchByproduct = computed(() => {
  return productStore.products.filter((product: Product) => {
    return (
      product.name.toLowerCase().includes(search.value.toLowerCase()) ||
      product.id?.toExponential().includes(search.value.toLowerCase())
    )
  })
})
</script>

<template>
  <StockDialog></StockDialog>
  <v-card theme="light" height="919" outlined="false">
    <v-row class="mt-5">
      <v-col cols="5"><span class="fontTitle ml-14">สินค้าคงคลัง</span></v-col>
      <v-col></v-col>
      <v-col cols="2">
        <v-btn class="font">ชื่อผู้ใช้ : บีมเองจ้า</v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="4">
        <v-text-field
          v-model="search"
          label="ค้นหาสินค้า"
          prepend-inner-icon="mdi-magnify"
          single-line
          rounded
          theme="light"
          variant="solo"
          class="custom-width ml-14"
        ></v-text-field>
      </v-col>
      <v-col cols="6"></v-col>
      <v-col><v-btn class="font" to="/adjuststock">ปรับปรุงจำนวนสินค้า</v-btn></v-col>
    </v-row>
    <v-row class="mt-2">
      <v-col></v-col>
      <v-col>
        <v-card
          theme="light"
          height="600"
          width="1800"
          style="border: 1px solid rgba(0, 0, 0, 0.1); overflow-y: auto; max-height: 500px"
        >
          <v-table style="font-family: Arial, Helvetica, sans-serif">
            <thead>
              <tr style="background-color: #54a4ee; color: #f1f1f1">
                <th style="color: white">รูป</th>
                <th style="color: white">รหัสสินค้า</th>
                <th style="color: white">ชื่อสินค้า</th>
                <th style="color: white">ราคา(บาท)</th>
                <th style="color: white">คงเหลือ</th>
                <th style="color: white">สถานะ</th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="item in searchByproduct"
                :key="item.id"
                @click="selectProduct(item)"
                :style="{ backgroundColor: isSelected(item) ? '#c2c2c2' : 'inherit' }"
              >
                <td>
                  <v-img :src="`${backendURL}/products/image/${item.image}`" height="128px"></v-img>
                </td>
                <td>{{ item.id }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.price }}</td>
                <td>{{ item.qtybefore }}</td>
                <td>
                  <v-chip
                    variant="elevated"
                    :color="
                      item.qtybefore === 0
                        ? 'red'
                        : item.qtybefore <= item.minquantity
                          ? 'yellow'
                          : 'green'
                    "
                    dark
                  >
                    {{
                      item.qtybefore === 0
                        ? 'สินค้าหมด'
                        : item.qtybefore < item.minquantity
                          ? 'ใกล้หมด'
                          : 'พร้อมขาย'
                    }}
                  </v-chip>
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-card>
      </v-col>
      <v-col></v-col>
    </v-row>
    <v-row class="mt-4">
      <v-col cols="3" class="ml-13">
        <v-btn to="/management" class="font"> <v-icon>mdi-arrow-left</v-icon> ย้อนกลับ </v-btn>
        
        <v-btn to="/" class="font ml-5"> <v-icon>mdi-home</v-icon> กลับหน้าหลัก </v-btn>
      </v-col>
      <v-col cols="8" class="text-right">
        <v-btn class="font ml-5" @click="productStore.dialog = true">
          <v-icon>mdi-plus</v-icon> เพิ่มสินค้า
        </v-btn>

        <v-btn v-if="!selectedProduct" class="font ml-5">
          <v-icon>mdi-pencil</v-icon> แก้ไขสินค้า
        </v-btn>
        <v-btn v-else class="font ml-5" @click="editProduct(selectedProduct)">
          <v-icon>mdi-pencil</v-icon> แก้ไขสินค้า
        </v-btn>

        <v-btn v-if="!selectedProduct" class="font ml-5">
          <v-icon>mdi-delete</v-icon> ลบสินค้า
        </v-btn>
        <v-btn v-else class="font ml-5" @click="deleteProduct(selectedProduct.id!)">
          <v-icon>mdi-delete</v-icon> ลบสินค้า
        </v-btn>
      </v-col>
    </v-row>
  </v-card>
</template>

<style scoped>
.custom-width {
  width: 500px;
}

.fontTitle {
  text-align-last: center;
  font-family: fantasy;
  font-size: 35px;
  color: black;
}

.fontbtn {
  text-align-last: center;
  font-family: fantasy;
  font-size: 30px;
  color: black;
}

.font {
  text-align-last: center;
  font-family: fantasy;
  font-size: 18px;
  color: black;
}
</style>
